<?php
header("Access-Control-Allow-Origin: *");
require_once ('phpQuery-onefile.php');
set_time_limit(700);

$options = array(
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_SSL_VERIFYPEER => false,
  CURLOPT_HEADER => false,
  CURLOPT_USERAGENT => 'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:47.0) Gecko/20100101 Firefox/47.0',
  CURLOPT_ENCODING => "",
  CURLOPT_REFERER => "https://lenov.ru",
);




if (isset($_POST['url'])) {

scrap_lenov($_POST['url']);

}



function scrap_lenov($url) {
  $big_data = array();
  $year = (string) date('Y');
  $month = (string) date('m');

  if (!file_exists('./f')) {
 mkdir('./f');
  }
  if (!file_exists('./f/'.$year)){
    mkdir('./f/'.$year);
  }
  if (!file_exists('./f/'.$year.'/'.$month)){
    mkdir('./f/'.$year.'/'.$month);
  }

  $symbols = array(
    '-lenov.ru', '.apk',':', "?", "/", '\\', '*', '<', '>', '&', '|', '</b>',' ', '_lenov.ru',
  );

  global $options;
  if (strpos($url, 'lenov.ru') === false) {
    echo 'make sure that this link belongs to https://lenov.ru';
    return;
  }

  $ch = curl_init($url);
  curl_setopt_array($ch,  $options);
  $html = curl_exec($ch);
  curl_close($ch);


  $dom = phpQuery::newDocument($html);
  $elems = $dom->find('.attachment a');
  #18+ links
  if (!$elems) {
    echo json_encode(array('18+ content/'));
    return;
  }


  $links = array();
  $titles = array();

  foreach ($elems as $elem) {
    $links[] = 'https://lenov.ru'. pq($elem)->attr('href');
    $titles[] = str_replace($symbols, '', pq($elem)->text());
  }


  $curls = multi_curl_process($links);
  unset($links);
  $links = array();
  foreach ($curls as $link ) {
    $html = curl_multi_getcontent($link);
    $dom = phpQuery::newDocument($html);
    $links[] = 'https://lenov.ru'. $dom->find('#linker')->attr('href');
  }


  $curls = multi_curl_process($links);
  $result = array();
  $i = 0;
  foreach ($curls as $link ) {
      $arr = array();
      $html = curl_multi_getcontent($link);

      $path = "./f/$year/$month/".$titles[$i].".apk";
      $f = fopen($path, 'w+');
      fwrite($f,$html);
      fclose($f);

      $arr[] = "https://". $_SERVER['HTTP_HOST'] . "/f/$year/$month/".$titles[$i].".apk";
      $arr[] = round((float) ((float) filesize($path) / (1024*1024)),1);
      $result[] = $arr;
      $i++;
  }


  echo json_encode($result);
}




function multi_curl_process($links) {
  $multi = curl_multi_init();
  $curls = array();
  // add links to curl multi
  foreach ($links as $link) {
    global $options;
    $ch = curl_init($link);
    curl_setopt_array($ch, $options);
    curl_multi_add_handle($multi, $ch);
    $curls[$link] = $ch;
  }

  // execute links
  do {
      $mrc = curl_multi_exec($multi, $active);
  } while ($mrc == CURLM_CALL_MULTI_PERFORM);

  while ($active && $mrc == CURLM_OK) {
      if (curl_multi_select($multi) != -1) {
          do {
              $mrc = curl_multi_exec($multi, $active);
          } while ($mrc == CURLM_CALL_MULTI_PERFORM);
      }
  }

 return $curls;
}

?>
