<?php
header("Access-Control-Allow-Origin: *");
require_once ('phpQuery-onefile.php');
set_time_limit(700);

$zip_url = 'https://dl.apkhome.net';


$options = array(
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_SSL_VERIFYPEER => false,
  CURLOPT_HEADER => false,
  CURLOPT_USERAGENT => 'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:47.0) Gecko/20100101 Firefox/47.0',
  CURLOPT_ENCODING => "",
);



if (isset($_POST['url'])) {
  scrap_droid($_POST['url']);
}





function scrap_droid($url) {
  global $zip_url;
  $zips = array();
  $year = (string) date('Y');
  $month = (string) date('m');

  if (!file_exists('./f')) {
 mkdir('./f');
  }
  if (!file_exists('./f/'.$year)){
    mkdir('./f/'.$year);
  }
  if (!file_exists('./f/'.$year.'/'.$month)){
    mkdir('./f/'.$year.'/'.$month);
  }

  $symbols = array(
    '-lenov.ru', '.apk',':', "?", "/", '\\', '*', '<', '>', '&', '|', '</b>',' ',
  );

  global $options;
  if (strpos($url, 'moddroid.com') === false) {
    echo 'make sure that this link belongs to https://moddroid.com';
    return;
  }

  $ch = curl_init($url);
  curl_setopt_array($ch,  $options);
  $html = curl_exec($ch);
  curl_close($ch);


  $dom = phpQuery::newDocument($html);
  $elems = $dom->find('#primary > a:nth-child(3)');


  $links = array();
  $titles = array();


  foreach ($elems as $elem) {
    $links[] =  pq($elem)->attr('href');
  }


  $curls = multi_curl_process($links);
  unset($links);
  $links = array();
  foreach ($curls as $link ) {
    $html = curl_multi_getcontent($link);
    $dom = phpQuery::newDocument($html);
    $elems = $dom->find('div.mb-3 > div.collapse > a');
    foreach ($elems as $elem) {
      $links[] = pq($elem)->attr('href');
    }
  }

  $curls = multi_curl_process($links);
  unset($links);
  $links = array();
  foreach ($curls as $link ) {
    $html = curl_multi_getcontent($link);
    $dom = phpQuery::newDocument($html);

    $elems = $dom->find('#click-here');
    foreach ($elems as $elem) {
      if (strpos(pq($elem)->attr('href'), '.zip') !== false) {
        $a = explode('/', pq($elem)->attr('href'));
        $zips[] = array(pq($elem)->attr('href'), $a[count($a) - 1]);
        continue;
      }

      $links[] = pq($elem)->attr('href');
      $a = explode('/', pq($elem)->attr('href'));
      $titles[] = $a[count($a) - 1];
    }
  }

  #result of function
  $result = array();

 


  #upload apk files to this server
  $curls = multi_curl_process($links);

  $i = 0;
  foreach ($curls as $link ) {
      $arr = array();
      $html = curl_multi_getcontent($link);

      $path = "./f/$year/$month/".$titles[$i];
      $f = fopen($path, 'w+');
      fwrite($f,$html);
      fclose($f);

      $arr[] = "https://". $_SERVER['HTTP_HOST'] . "/f/$year/$month/".$titles[$i];
      $arr[] = round((float) filesize($path) / (1024*1024), 1);
      $result[] = $arr;
      $i++;
  }
  
  
   #send zip files to zip server
  if (count($zips) != 0) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $zip_url."/moddroidzip.php");
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, "data=". json_encode($zips));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    $arr = curl_exec($ch);
    curl_close ($ch);

    #save result from server
    foreach (json_decode($arr) as $value) {
      $result[] = $value;
    }
  }


  echo json_encode($result);
}




function multi_curl_process($links) {
  $multi = curl_multi_init();
  $curls = array();
  // add links to curl multi
  foreach ($links as $link) {
    global $options;
    $ch = curl_init($link);
    curl_setopt_array($ch, $options);
    curl_multi_add_handle($multi, $ch);
    $curls[$link] = $ch;
  }

  // execute links
  do {
      $mrc = curl_multi_exec($multi, $active);
  } while ($mrc == CURLM_CALL_MULTI_PERFORM);

  while ($active && $mrc == CURLM_OK) {
      if (curl_multi_select($multi) != -1) {
          do {
              $mrc = curl_multi_exec($multi, $active);
          } while ($mrc == CURLM_CALL_MULTI_PERFORM);
      }
  }

 return $curls;
}

?>
