<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: text/html; charset=utf-8");
require_once ('phpQuery-onefile.php');
set_time_limit(700);



$options = array(
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_USERAGENT => 'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:47.0) Gecko/20100101 Firefox/47.0',
  CURLOPT_ENCODING => "",
);


// start
if (isset($_POST['start'])) {
  if (!file_exists('./f')) {
 mkdir('./f');
  }
  get_links($_POST['url']);
}



function get_links($url) {
  global $main_url;
  $big_data = array();
  $year = (string) date('Y');
  $month = (string) date('m');
  if (!file_exists('./f/'.$year)){
    mkdir('./f/'.$year);
  }
  if (!file_exists('./f/'.$year.'/'.$month)){
    mkdir('./f/'.$year.'/'.$month);
  }
  $symbols = array(
    '-t-5play.ru', '-5play.ru', '-t-5play', '-t-5plau.ru', '-5play', '.apk',':', "?", "/", '\\', '*', '<', '>', '&', '|',
  );
  global $options;
  if (strpos($url, '5play.ru') === false) {
    echo 'make sure that this link belongs to https://5play.ru';
    return;
  }
  $ch = curl_init($url);
  curl_setopt_array($ch,  $options);
  $html = curl_exec($ch);
  curl_close($ch);
  $dom = phpQuery::newDocument($html);
  #link of download file
  $elems = $dom->find('#dle-content > article > div.wrp-min.block-list > div.block.b-download > div.b-cont > div.downline-line-list > a');
  $links = array();
  $titles = array();
  #title of link of download file
  $title = $dom->find('#dle-content > article > div.wrp-min.block-list > div.block.b-download > div.b-cont > div.downline-line-list > a > div > span');
  $arr = array();
  $types = array();
  foreach ($title as $value) {
    $arr[] = str_replace($symbols, '', pq($value)->text());
    if (strpos(pq($value)->text(), '.zip') === false) {
      $types[] = '.apk';
    }else {
      $types[] = '';
    }
  }
  $title = $arr;

  foreach ($elems as $elem) {
    $links[] = pq($elem)->attr('href');
  }
  #just count how many links
  $sizes = $dom->find('#dle-content > article > div.wrp-min.block-list > div.block.b-download > div.b-cont > div.downline-line-list > a > div > span');


  $curls = multi_curl_process($links);
  unset($links);
  $links = array();
  foreach ($curls as $link ) {
    $html = curl_multi_getcontent($link);
    $dom = phpQuery::newDocument($html);
    if (!$dom->find('.download-btn > a')->attr('href')) {
      echo json_encode(array('selectors was changed'));
      return;
    }
    #take link of download file to server directly
    $links[] = $dom->find('.download-btn > a')->attr('href');
  }
  $i = 0;
  foreach ($sizes as $size) {
    if($types[$i] == '') {
      $big_data[] = array($links[$i], $title[$i]);
      unset($links[$i]);
    }
    $i++;
  }


  $curls = multi_curl_process($links);
  $result = array();
  $i = 0;
  foreach ($curls as $link ) {
      $arr = array();
      $html = curl_multi_getcontent($link);
      $path = "./f/$year/$month/".$title[$i].$types[$i];
      $f = fopen($path, 'w+');
      fwrite($f,$html);
      fclose($f);
      $arr[] = "https://". $_SERVER['HTTP_HOST'] . "/f/$year/$month/".$title[$i].$types[$i];
      $arr[] = round((float) filesize($path) / (1024 * 1024) ,1);
      $result[] = $arr;
      $i++;
  }


  echo json_encode($result);
}



function multi_curl_process($links) {
  $multi = curl_multi_init();
  $curls = array();
  // add links to curl multi
  foreach ($links as $link) {
    global $options;
    $ch = curl_init($link);
    curl_setopt_array($ch, $options);
    curl_multi_add_handle($multi, $ch);
    $curls[$link] = $ch;
  }

  // execute links
  do {
      $mrc = curl_multi_exec($multi, $active);
  } while ($mrc == CURLM_CALL_MULTI_PERFORM);

  while ($active && $mrc == CURLM_OK) {
      if (curl_multi_select($multi) != -1) {
          do {
              $mrc = curl_multi_exec($multi, $active);
          } while ($mrc == CURLM_CALL_MULTI_PERFORM);
      }
  }

 return $curls;
}

 ?>
